'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var styles = {
  "container": "StickyWrapper-module__OCgRGPAL__v2-1-1",
  "stickyContainer": "StickyWrapper-module__mCeEdcun__v2-1-1"
};
var getAllParents = function (node) {
  var parents = [];
  var tmpNode = node;
  while (tmpNode) {
    parents.unshift(tmpNode);
    tmpNode = tmpNode.parentElement instanceof HTMLElement ? tmpNode.parentElement : null;
  }
  return parents;
};
function StickyWrapper(_a) {
  var children = _a.children,
    rootElementId = _a.rootElementId;
  var stickyWrapper = React__default["default"].useRef(null);
  React__default["default"].useEffect(function () {
    var rootElement;
    if (rootElementId) {
      rootElement = window.document.getElementById(rootElementId);
    } else {
      rootElement = stickyWrapper.current ? stickyWrapper.current.parentElement : null;
    }
    if (rootElement) {
      rootElement.dataset.originalDisplayValue = rootElement.style.display;
      rootElement.style.display = 'contents';
    }
    var alerts = window.document.querySelectorAll('.alert');
    alerts.forEach(function (alert) {
      // eslint-disable-next-line no-param-reassign
      alert.dataset.originalLeftValue = alert.style.left;
      // eslint-disable-next-line no-param-reassign
      alert.dataset.originalPositionValue = alert.style.position;
      // eslint-disable-next-line no-param-reassign
      alert.style.left = '0';
      // eslint-disable-next-line no-param-reassign
      alert.style.position = 'sticky';
    });
    var pageContainer = window.document.getElementById('page-container');
    if (pageContainer) {
      pageContainer.dataset.originalOverflowValue = pageContainer.style.overflow;
      pageContainer.style.overflow = 'auto';
    }
    var parents = getAllParents(rootElement);
    var parentsToChangeToDisplayContents = parents.slice(parents.findIndex(function (parent) {
      return parent.id === 'page-content';
    }));
    var displayValuesOfParents = parentsToChangeToDisplayContents.map(function (parent) {
      return parent.style.display;
    });
    parentsToChangeToDisplayContents.forEach(function (parent) {
      // eslint-disable-next-line no-param-reassign
      parent.style.display = 'contents';
    });
    return function cleanup() {
      var _a;
      if (rootElement) {
        rootElement.style.display = (_a = rootElement.dataset.originalDisplayValue) !== null && _a !== void 0 ? _a : '';
      }
      alerts.forEach(function (alert) {
        var _a;
        // eslint-disable-next-line no-param-reassign
        alert.style.left = (_a = alert.dataset.originalLeftValue) !== null && _a !== void 0 ? _a : '';
        // eslint-disable-next-line no-param-reassign
        alert.style.position = alert.dataset.originalPositionValue;
      });
      if (pageContainer) {
        pageContainer.style.overflow = pageContainer.dataset.originalOverflowValue;
      }
      if (parentsToChangeToDisplayContents) {
        parentsToChangeToDisplayContents.forEach(function (parent, index) {
          // eslint-disable-next-line no-param-reassign
          parent.style.display = displayValuesOfParents[index];
        });
      }
    };
  }, [rootElementId]);
  return React__default["default"].createElement("div", {
    className: styles.container,
    ref: stickyWrapper
  }, typeof children === 'function' ? children(styles.stickyContainer) : children);
}
exports.StickyWrapper = StickyWrapper;
//# sourceMappingURL=index.js.map
